import { Signer } from "ethers";
import type { Provider } from "@ethersproject/providers";
import type { NitroAdjudicator, NitroAdjudicatorInterface } from "../NitroAdjudicator";
export declare class NitroAdjudicator__factory {
    static readonly abi: readonly [{
        readonly anonymous: false;
        readonly inputs: readonly [{
            readonly indexed: true;
            readonly internalType: "bytes32";
            readonly name: "channelId";
            readonly type: "bytes32";
        }, {
            readonly indexed: false;
            readonly internalType: "uint256";
            readonly name: "assetIndex";
            readonly type: "uint256";
        }, {
            readonly indexed: false;
            readonly internalType: "uint256";
            readonly name: "initialHoldings";
            readonly type: "uint256";
        }, {
            readonly indexed: false;
            readonly internalType: "uint256";
            readonly name: "finalHoldings";
            readonly type: "uint256";
        }];
        readonly name: "AllocationUpdated";
        readonly type: "event";
    }, {
        readonly anonymous: false;
        readonly inputs: readonly [{
            readonly indexed: true;
            readonly internalType: "bytes32";
            readonly name: "channelId";
            readonly type: "bytes32";
        }, {
            readonly indexed: false;
            readonly internalType: "uint48";
            readonly name: "newTurnNumRecord";
            readonly type: "uint48";
        }];
        readonly name: "ChallengeCleared";
        readonly type: "event";
    }, {
        readonly anonymous: false;
        readonly inputs: readonly [{
            readonly indexed: true;
            readonly internalType: "bytes32";
            readonly name: "channelId";
            readonly type: "bytes32";
        }, {
            readonly indexed: false;
            readonly internalType: "uint48";
            readonly name: "finalizesAt";
            readonly type: "uint48";
        }, {
            readonly components: readonly [{
                readonly components: readonly [{
                    readonly components: readonly [{
                        readonly internalType: "address";
                        readonly name: "asset";
                        readonly type: "address";
                    }, {
                        readonly components: readonly [{
                            readonly internalType: "enum ExitFormat.AssetType";
                            readonly name: "assetType";
                            readonly type: "uint8";
                        }, {
                            readonly internalType: "bytes";
                            readonly name: "metadata";
                            readonly type: "bytes";
                        }];
                        readonly internalType: "struct ExitFormat.AssetMetadata";
                        readonly name: "assetMetadata";
                        readonly type: "tuple";
                    }, {
                        readonly components: readonly [{
                            readonly internalType: "bytes32";
                            readonly name: "destination";
                            readonly type: "bytes32";
                        }, {
                            readonly internalType: "uint256";
                            readonly name: "amount";
                            readonly type: "uint256";
                        }, {
                            readonly internalType: "uint8";
                            readonly name: "allocationType";
                            readonly type: "uint8";
                        }, {
                            readonly internalType: "bytes";
                            readonly name: "metadata";
                            readonly type: "bytes";
                        }];
                        readonly internalType: "struct ExitFormat.Allocation[]";
                        readonly name: "allocations";
                        readonly type: "tuple[]";
                    }];
                    readonly internalType: "struct ExitFormat.SingleAssetExit[]";
                    readonly name: "outcome";
                    readonly type: "tuple[]";
                }, {
                    readonly internalType: "bytes";
                    readonly name: "appData";
                    readonly type: "bytes";
                }, {
                    readonly internalType: "uint48";
                    readonly name: "turnNum";
                    readonly type: "uint48";
                }, {
                    readonly internalType: "bool";
                    readonly name: "isFinal";
                    readonly type: "bool";
                }];
                readonly internalType: "struct INitroTypes.VariablePart";
                readonly name: "variablePart";
                readonly type: "tuple";
            }, {
                readonly components: readonly [{
                    readonly internalType: "uint8";
                    readonly name: "v";
                    readonly type: "uint8";
                }, {
                    readonly internalType: "bytes32";
                    readonly name: "r";
                    readonly type: "bytes32";
                }, {
                    readonly internalType: "bytes32";
                    readonly name: "s";
                    readonly type: "bytes32";
                }];
                readonly internalType: "struct INitroTypes.Signature[]";
                readonly name: "sigs";
                readonly type: "tuple[]";
            }];
            readonly indexed: false;
            readonly internalType: "struct INitroTypes.SignedVariablePart[]";
            readonly name: "proof";
            readonly type: "tuple[]";
        }, {
            readonly components: readonly [{
                readonly components: readonly [{
                    readonly components: readonly [{
                        readonly internalType: "address";
                        readonly name: "asset";
                        readonly type: "address";
                    }, {
                        readonly components: readonly [{
                            readonly internalType: "enum ExitFormat.AssetType";
                            readonly name: "assetType";
                            readonly type: "uint8";
                        }, {
                            readonly internalType: "bytes";
                            readonly name: "metadata";
                            readonly type: "bytes";
                        }];
                        readonly internalType: "struct ExitFormat.AssetMetadata";
                        readonly name: "assetMetadata";
                        readonly type: "tuple";
                    }, {
                        readonly components: readonly [{
                            readonly internalType: "bytes32";
                            readonly name: "destination";
                            readonly type: "bytes32";
                        }, {
                            readonly internalType: "uint256";
                            readonly name: "amount";
                            readonly type: "uint256";
                        }, {
                            readonly internalType: "uint8";
                            readonly name: "allocationType";
                            readonly type: "uint8";
                        }, {
                            readonly internalType: "bytes";
                            readonly name: "metadata";
                            readonly type: "bytes";
                        }];
                        readonly internalType: "struct ExitFormat.Allocation[]";
                        readonly name: "allocations";
                        readonly type: "tuple[]";
                    }];
                    readonly internalType: "struct ExitFormat.SingleAssetExit[]";
                    readonly name: "outcome";
                    readonly type: "tuple[]";
                }, {
                    readonly internalType: "bytes";
                    readonly name: "appData";
                    readonly type: "bytes";
                }, {
                    readonly internalType: "uint48";
                    readonly name: "turnNum";
                    readonly type: "uint48";
                }, {
                    readonly internalType: "bool";
                    readonly name: "isFinal";
                    readonly type: "bool";
                }];
                readonly internalType: "struct INitroTypes.VariablePart";
                readonly name: "variablePart";
                readonly type: "tuple";
            }, {
                readonly components: readonly [{
                    readonly internalType: "uint8";
                    readonly name: "v";
                    readonly type: "uint8";
                }, {
                    readonly internalType: "bytes32";
                    readonly name: "r";
                    readonly type: "bytes32";
                }, {
                    readonly internalType: "bytes32";
                    readonly name: "s";
                    readonly type: "bytes32";
                }];
                readonly internalType: "struct INitroTypes.Signature[]";
                readonly name: "sigs";
                readonly type: "tuple[]";
            }];
            readonly indexed: false;
            readonly internalType: "struct INitroTypes.SignedVariablePart";
            readonly name: "candidate";
            readonly type: "tuple";
        }];
        readonly name: "ChallengeRegistered";
        readonly type: "event";
    }, {
        readonly anonymous: false;
        readonly inputs: readonly [{
            readonly indexed: true;
            readonly internalType: "bytes32";
            readonly name: "channelId";
            readonly type: "bytes32";
        }, {
            readonly indexed: false;
            readonly internalType: "uint48";
            readonly name: "finalizesAt";
            readonly type: "uint48";
        }];
        readonly name: "Concluded";
        readonly type: "event";
    }, {
        readonly anonymous: false;
        readonly inputs: readonly [{
            readonly indexed: true;
            readonly internalType: "bytes32";
            readonly name: "destination";
            readonly type: "bytes32";
        }, {
            readonly indexed: false;
            readonly internalType: "address";
            readonly name: "asset";
            readonly type: "address";
        }, {
            readonly indexed: false;
            readonly internalType: "uint256";
            readonly name: "destinationHoldings";
            readonly type: "uint256";
        }];
        readonly name: "Deposited";
        readonly type: "event";
    }, {
        readonly anonymous: false;
        readonly inputs: readonly [{
            readonly indexed: true;
            readonly internalType: "bytes32";
            readonly name: "channelId";
            readonly type: "bytes32";
        }, {
            readonly indexed: false;
            readonly internalType: "uint256";
            readonly name: "assetIndex";
            readonly type: "uint256";
        }];
        readonly name: "Reclaimed";
        readonly type: "event";
    }, {
        readonly inputs: readonly [{
            readonly components: readonly [{
                readonly internalType: "address[]";
                readonly name: "participants";
                readonly type: "address[]";
            }, {
                readonly internalType: "uint64";
                readonly name: "channelNonce";
                readonly type: "uint64";
            }, {
                readonly internalType: "address";
                readonly name: "appDefinition";
                readonly type: "address";
            }, {
                readonly internalType: "uint48";
                readonly name: "challengeDuration";
                readonly type: "uint48";
            }];
            readonly internalType: "struct INitroTypes.FixedPart";
            readonly name: "fixedPart";
            readonly type: "tuple";
        }, {
            readonly components: readonly [{
                readonly components: readonly [{
                    readonly components: readonly [{
                        readonly internalType: "address";
                        readonly name: "asset";
                        readonly type: "address";
                    }, {
                        readonly components: readonly [{
                            readonly internalType: "enum ExitFormat.AssetType";
                            readonly name: "assetType";
                            readonly type: "uint8";
                        }, {
                            readonly internalType: "bytes";
                            readonly name: "metadata";
                            readonly type: "bytes";
                        }];
                        readonly internalType: "struct ExitFormat.AssetMetadata";
                        readonly name: "assetMetadata";
                        readonly type: "tuple";
                    }, {
                        readonly components: readonly [{
                            readonly internalType: "bytes32";
                            readonly name: "destination";
                            readonly type: "bytes32";
                        }, {
                            readonly internalType: "uint256";
                            readonly name: "amount";
                            readonly type: "uint256";
                        }, {
                            readonly internalType: "uint8";
                            readonly name: "allocationType";
                            readonly type: "uint8";
                        }, {
                            readonly internalType: "bytes";
                            readonly name: "metadata";
                            readonly type: "bytes";
                        }];
                        readonly internalType: "struct ExitFormat.Allocation[]";
                        readonly name: "allocations";
                        readonly type: "tuple[]";
                    }];
                    readonly internalType: "struct ExitFormat.SingleAssetExit[]";
                    readonly name: "outcome";
                    readonly type: "tuple[]";
                }, {
                    readonly internalType: "bytes";
                    readonly name: "appData";
                    readonly type: "bytes";
                }, {
                    readonly internalType: "uint48";
                    readonly name: "turnNum";
                    readonly type: "uint48";
                }, {
                    readonly internalType: "bool";
                    readonly name: "isFinal";
                    readonly type: "bool";
                }];
                readonly internalType: "struct INitroTypes.VariablePart";
                readonly name: "variablePart";
                readonly type: "tuple";
            }, {
                readonly components: readonly [{
                    readonly internalType: "uint8";
                    readonly name: "v";
                    readonly type: "uint8";
                }, {
                    readonly internalType: "bytes32";
                    readonly name: "r";
                    readonly type: "bytes32";
                }, {
                    readonly internalType: "bytes32";
                    readonly name: "s";
                    readonly type: "bytes32";
                }];
                readonly internalType: "struct INitroTypes.Signature[]";
                readonly name: "sigs";
                readonly type: "tuple[]";
            }];
            readonly internalType: "struct INitroTypes.SignedVariablePart[]";
            readonly name: "proof";
            readonly type: "tuple[]";
        }, {
            readonly components: readonly [{
                readonly components: readonly [{
                    readonly components: readonly [{
                        readonly internalType: "address";
                        readonly name: "asset";
                        readonly type: "address";
                    }, {
                        readonly components: readonly [{
                            readonly internalType: "enum ExitFormat.AssetType";
                            readonly name: "assetType";
                            readonly type: "uint8";
                        }, {
                            readonly internalType: "bytes";
                            readonly name: "metadata";
                            readonly type: "bytes";
                        }];
                        readonly internalType: "struct ExitFormat.AssetMetadata";
                        readonly name: "assetMetadata";
                        readonly type: "tuple";
                    }, {
                        readonly components: readonly [{
                            readonly internalType: "bytes32";
                            readonly name: "destination";
                            readonly type: "bytes32";
                        }, {
                            readonly internalType: "uint256";
                            readonly name: "amount";
                            readonly type: "uint256";
                        }, {
                            readonly internalType: "uint8";
                            readonly name: "allocationType";
                            readonly type: "uint8";
                        }, {
                            readonly internalType: "bytes";
                            readonly name: "metadata";
                            readonly type: "bytes";
                        }];
                        readonly internalType: "struct ExitFormat.Allocation[]";
                        readonly name: "allocations";
                        readonly type: "tuple[]";
                    }];
                    readonly internalType: "struct ExitFormat.SingleAssetExit[]";
                    readonly name: "outcome";
                    readonly type: "tuple[]";
                }, {
                    readonly internalType: "bytes";
                    readonly name: "appData";
                    readonly type: "bytes";
                }, {
                    readonly internalType: "uint48";
                    readonly name: "turnNum";
                    readonly type: "uint48";
                }, {
                    readonly internalType: "bool";
                    readonly name: "isFinal";
                    readonly type: "bool";
                }];
                readonly internalType: "struct INitroTypes.VariablePart";
                readonly name: "variablePart";
                readonly type: "tuple";
            }, {
                readonly components: readonly [{
                    readonly internalType: "uint8";
                    readonly name: "v";
                    readonly type: "uint8";
                }, {
                    readonly internalType: "bytes32";
                    readonly name: "r";
                    readonly type: "bytes32";
                }, {
                    readonly internalType: "bytes32";
                    readonly name: "s";
                    readonly type: "bytes32";
                }];
                readonly internalType: "struct INitroTypes.Signature[]";
                readonly name: "sigs";
                readonly type: "tuple[]";
            }];
            readonly internalType: "struct INitroTypes.SignedVariablePart";
            readonly name: "candidate";
            readonly type: "tuple";
        }, {
            readonly components: readonly [{
                readonly internalType: "uint8";
                readonly name: "v";
                readonly type: "uint8";
            }, {
                readonly internalType: "bytes32";
                readonly name: "r";
                readonly type: "bytes32";
            }, {
                readonly internalType: "bytes32";
                readonly name: "s";
                readonly type: "bytes32";
            }];
            readonly internalType: "struct INitroTypes.Signature";
            readonly name: "challengerSig";
            readonly type: "tuple";
        }];
        readonly name: "challenge";
        readonly outputs: readonly [];
        readonly stateMutability: "nonpayable";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly components: readonly [{
                readonly internalType: "address[]";
                readonly name: "participants";
                readonly type: "address[]";
            }, {
                readonly internalType: "uint64";
                readonly name: "channelNonce";
                readonly type: "uint64";
            }, {
                readonly internalType: "address";
                readonly name: "appDefinition";
                readonly type: "address";
            }, {
                readonly internalType: "uint48";
                readonly name: "challengeDuration";
                readonly type: "uint48";
            }];
            readonly internalType: "struct INitroTypes.FixedPart";
            readonly name: "fixedPart";
            readonly type: "tuple";
        }, {
            readonly components: readonly [{
                readonly components: readonly [{
                    readonly components: readonly [{
                        readonly internalType: "address";
                        readonly name: "asset";
                        readonly type: "address";
                    }, {
                        readonly components: readonly [{
                            readonly internalType: "enum ExitFormat.AssetType";
                            readonly name: "assetType";
                            readonly type: "uint8";
                        }, {
                            readonly internalType: "bytes";
                            readonly name: "metadata";
                            readonly type: "bytes";
                        }];
                        readonly internalType: "struct ExitFormat.AssetMetadata";
                        readonly name: "assetMetadata";
                        readonly type: "tuple";
                    }, {
                        readonly components: readonly [{
                            readonly internalType: "bytes32";
                            readonly name: "destination";
                            readonly type: "bytes32";
                        }, {
                            readonly internalType: "uint256";
                            readonly name: "amount";
                            readonly type: "uint256";
                        }, {
                            readonly internalType: "uint8";
                            readonly name: "allocationType";
                            readonly type: "uint8";
                        }, {
                            readonly internalType: "bytes";
                            readonly name: "metadata";
                            readonly type: "bytes";
                        }];
                        readonly internalType: "struct ExitFormat.Allocation[]";
                        readonly name: "allocations";
                        readonly type: "tuple[]";
                    }];
                    readonly internalType: "struct ExitFormat.SingleAssetExit[]";
                    readonly name: "outcome";
                    readonly type: "tuple[]";
                }, {
                    readonly internalType: "bytes";
                    readonly name: "appData";
                    readonly type: "bytes";
                }, {
                    readonly internalType: "uint48";
                    readonly name: "turnNum";
                    readonly type: "uint48";
                }, {
                    readonly internalType: "bool";
                    readonly name: "isFinal";
                    readonly type: "bool";
                }];
                readonly internalType: "struct INitroTypes.VariablePart";
                readonly name: "variablePart";
                readonly type: "tuple";
            }, {
                readonly components: readonly [{
                    readonly internalType: "uint8";
                    readonly name: "v";
                    readonly type: "uint8";
                }, {
                    readonly internalType: "bytes32";
                    readonly name: "r";
                    readonly type: "bytes32";
                }, {
                    readonly internalType: "bytes32";
                    readonly name: "s";
                    readonly type: "bytes32";
                }];
                readonly internalType: "struct INitroTypes.Signature[]";
                readonly name: "sigs";
                readonly type: "tuple[]";
            }];
            readonly internalType: "struct INitroTypes.SignedVariablePart[]";
            readonly name: "proof";
            readonly type: "tuple[]";
        }, {
            readonly components: readonly [{
                readonly components: readonly [{
                    readonly components: readonly [{
                        readonly internalType: "address";
                        readonly name: "asset";
                        readonly type: "address";
                    }, {
                        readonly components: readonly [{
                            readonly internalType: "enum ExitFormat.AssetType";
                            readonly name: "assetType";
                            readonly type: "uint8";
                        }, {
                            readonly internalType: "bytes";
                            readonly name: "metadata";
                            readonly type: "bytes";
                        }];
                        readonly internalType: "struct ExitFormat.AssetMetadata";
                        readonly name: "assetMetadata";
                        readonly type: "tuple";
                    }, {
                        readonly components: readonly [{
                            readonly internalType: "bytes32";
                            readonly name: "destination";
                            readonly type: "bytes32";
                        }, {
                            readonly internalType: "uint256";
                            readonly name: "amount";
                            readonly type: "uint256";
                        }, {
                            readonly internalType: "uint8";
                            readonly name: "allocationType";
                            readonly type: "uint8";
                        }, {
                            readonly internalType: "bytes";
                            readonly name: "metadata";
                            readonly type: "bytes";
                        }];
                        readonly internalType: "struct ExitFormat.Allocation[]";
                        readonly name: "allocations";
                        readonly type: "tuple[]";
                    }];
                    readonly internalType: "struct ExitFormat.SingleAssetExit[]";
                    readonly name: "outcome";
                    readonly type: "tuple[]";
                }, {
                    readonly internalType: "bytes";
                    readonly name: "appData";
                    readonly type: "bytes";
                }, {
                    readonly internalType: "uint48";
                    readonly name: "turnNum";
                    readonly type: "uint48";
                }, {
                    readonly internalType: "bool";
                    readonly name: "isFinal";
                    readonly type: "bool";
                }];
                readonly internalType: "struct INitroTypes.VariablePart";
                readonly name: "variablePart";
                readonly type: "tuple";
            }, {
                readonly components: readonly [{
                    readonly internalType: "uint8";
                    readonly name: "v";
                    readonly type: "uint8";
                }, {
                    readonly internalType: "bytes32";
                    readonly name: "r";
                    readonly type: "bytes32";
                }, {
                    readonly internalType: "bytes32";
                    readonly name: "s";
                    readonly type: "bytes32";
                }];
                readonly internalType: "struct INitroTypes.Signature[]";
                readonly name: "sigs";
                readonly type: "tuple[]";
            }];
            readonly internalType: "struct INitroTypes.SignedVariablePart";
            readonly name: "candidate";
            readonly type: "tuple";
        }];
        readonly name: "checkpoint";
        readonly outputs: readonly [];
        readonly stateMutability: "nonpayable";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly components: readonly [{
                readonly internalType: "bytes32";
                readonly name: "destination";
                readonly type: "bytes32";
            }, {
                readonly internalType: "uint256";
                readonly name: "amount";
                readonly type: "uint256";
            }, {
                readonly internalType: "uint8";
                readonly name: "allocationType";
                readonly type: "uint8";
            }, {
                readonly internalType: "bytes";
                readonly name: "metadata";
                readonly type: "bytes";
            }];
            readonly internalType: "struct ExitFormat.Allocation[]";
            readonly name: "sourceAllocations";
            readonly type: "tuple[]";
        }, {
            readonly components: readonly [{
                readonly internalType: "bytes32";
                readonly name: "destination";
                readonly type: "bytes32";
            }, {
                readonly internalType: "uint256";
                readonly name: "amount";
                readonly type: "uint256";
            }, {
                readonly internalType: "uint8";
                readonly name: "allocationType";
                readonly type: "uint8";
            }, {
                readonly internalType: "bytes";
                readonly name: "metadata";
                readonly type: "bytes";
            }];
            readonly internalType: "struct ExitFormat.Allocation[]";
            readonly name: "targetAllocations";
            readonly type: "tuple[]";
        }, {
            readonly internalType: "uint256";
            readonly name: "indexOfTargetInSource";
            readonly type: "uint256";
        }];
        readonly name: "compute_reclaim_effects";
        readonly outputs: readonly [{
            readonly components: readonly [{
                readonly internalType: "bytes32";
                readonly name: "destination";
                readonly type: "bytes32";
            }, {
                readonly internalType: "uint256";
                readonly name: "amount";
                readonly type: "uint256";
            }, {
                readonly internalType: "uint8";
                readonly name: "allocationType";
                readonly type: "uint8";
            }, {
                readonly internalType: "bytes";
                readonly name: "metadata";
                readonly type: "bytes";
            }];
            readonly internalType: "struct ExitFormat.Allocation[]";
            readonly name: "";
            readonly type: "tuple[]";
        }];
        readonly stateMutability: "pure";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "uint256";
            readonly name: "initialHoldings";
            readonly type: "uint256";
        }, {
            readonly components: readonly [{
                readonly internalType: "bytes32";
                readonly name: "destination";
                readonly type: "bytes32";
            }, {
                readonly internalType: "uint256";
                readonly name: "amount";
                readonly type: "uint256";
            }, {
                readonly internalType: "uint8";
                readonly name: "allocationType";
                readonly type: "uint8";
            }, {
                readonly internalType: "bytes";
                readonly name: "metadata";
                readonly type: "bytes";
            }];
            readonly internalType: "struct ExitFormat.Allocation[]";
            readonly name: "allocations";
            readonly type: "tuple[]";
        }, {
            readonly internalType: "uint256[]";
            readonly name: "indices";
            readonly type: "uint256[]";
        }];
        readonly name: "compute_transfer_effects_and_interactions";
        readonly outputs: readonly [{
            readonly components: readonly [{
                readonly internalType: "bytes32";
                readonly name: "destination";
                readonly type: "bytes32";
            }, {
                readonly internalType: "uint256";
                readonly name: "amount";
                readonly type: "uint256";
            }, {
                readonly internalType: "uint8";
                readonly name: "allocationType";
                readonly type: "uint8";
            }, {
                readonly internalType: "bytes";
                readonly name: "metadata";
                readonly type: "bytes";
            }];
            readonly internalType: "struct ExitFormat.Allocation[]";
            readonly name: "newAllocations";
            readonly type: "tuple[]";
        }, {
            readonly internalType: "bool";
            readonly name: "allocatesOnlyZeros";
            readonly type: "bool";
        }, {
            readonly components: readonly [{
                readonly internalType: "bytes32";
                readonly name: "destination";
                readonly type: "bytes32";
            }, {
                readonly internalType: "uint256";
                readonly name: "amount";
                readonly type: "uint256";
            }, {
                readonly internalType: "uint8";
                readonly name: "allocationType";
                readonly type: "uint8";
            }, {
                readonly internalType: "bytes";
                readonly name: "metadata";
                readonly type: "bytes";
            }];
            readonly internalType: "struct ExitFormat.Allocation[]";
            readonly name: "exitAllocations";
            readonly type: "tuple[]";
        }, {
            readonly internalType: "uint256";
            readonly name: "totalPayouts";
            readonly type: "uint256";
        }];
        readonly stateMutability: "pure";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly components: readonly [{
                readonly internalType: "address[]";
                readonly name: "participants";
                readonly type: "address[]";
            }, {
                readonly internalType: "uint64";
                readonly name: "channelNonce";
                readonly type: "uint64";
            }, {
                readonly internalType: "address";
                readonly name: "appDefinition";
                readonly type: "address";
            }, {
                readonly internalType: "uint48";
                readonly name: "challengeDuration";
                readonly type: "uint48";
            }];
            readonly internalType: "struct INitroTypes.FixedPart";
            readonly name: "fixedPart";
            readonly type: "tuple";
        }, {
            readonly components: readonly [{
                readonly components: readonly [{
                    readonly components: readonly [{
                        readonly internalType: "address";
                        readonly name: "asset";
                        readonly type: "address";
                    }, {
                        readonly components: readonly [{
                            readonly internalType: "enum ExitFormat.AssetType";
                            readonly name: "assetType";
                            readonly type: "uint8";
                        }, {
                            readonly internalType: "bytes";
                            readonly name: "metadata";
                            readonly type: "bytes";
                        }];
                        readonly internalType: "struct ExitFormat.AssetMetadata";
                        readonly name: "assetMetadata";
                        readonly type: "tuple";
                    }, {
                        readonly components: readonly [{
                            readonly internalType: "bytes32";
                            readonly name: "destination";
                            readonly type: "bytes32";
                        }, {
                            readonly internalType: "uint256";
                            readonly name: "amount";
                            readonly type: "uint256";
                        }, {
                            readonly internalType: "uint8";
                            readonly name: "allocationType";
                            readonly type: "uint8";
                        }, {
                            readonly internalType: "bytes";
                            readonly name: "metadata";
                            readonly type: "bytes";
                        }];
                        readonly internalType: "struct ExitFormat.Allocation[]";
                        readonly name: "allocations";
                        readonly type: "tuple[]";
                    }];
                    readonly internalType: "struct ExitFormat.SingleAssetExit[]";
                    readonly name: "outcome";
                    readonly type: "tuple[]";
                }, {
                    readonly internalType: "bytes";
                    readonly name: "appData";
                    readonly type: "bytes";
                }, {
                    readonly internalType: "uint48";
                    readonly name: "turnNum";
                    readonly type: "uint48";
                }, {
                    readonly internalType: "bool";
                    readonly name: "isFinal";
                    readonly type: "bool";
                }];
                readonly internalType: "struct INitroTypes.VariablePart";
                readonly name: "variablePart";
                readonly type: "tuple";
            }, {
                readonly components: readonly [{
                    readonly internalType: "uint8";
                    readonly name: "v";
                    readonly type: "uint8";
                }, {
                    readonly internalType: "bytes32";
                    readonly name: "r";
                    readonly type: "bytes32";
                }, {
                    readonly internalType: "bytes32";
                    readonly name: "s";
                    readonly type: "bytes32";
                }];
                readonly internalType: "struct INitroTypes.Signature[]";
                readonly name: "sigs";
                readonly type: "tuple[]";
            }];
            readonly internalType: "struct INitroTypes.SignedVariablePart";
            readonly name: "candidate";
            readonly type: "tuple";
        }];
        readonly name: "conclude";
        readonly outputs: readonly [];
        readonly stateMutability: "nonpayable";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly components: readonly [{
                readonly internalType: "address[]";
                readonly name: "participants";
                readonly type: "address[]";
            }, {
                readonly internalType: "uint64";
                readonly name: "channelNonce";
                readonly type: "uint64";
            }, {
                readonly internalType: "address";
                readonly name: "appDefinition";
                readonly type: "address";
            }, {
                readonly internalType: "uint48";
                readonly name: "challengeDuration";
                readonly type: "uint48";
            }];
            readonly internalType: "struct INitroTypes.FixedPart";
            readonly name: "fixedPart";
            readonly type: "tuple";
        }, {
            readonly components: readonly [{
                readonly components: readonly [{
                    readonly components: readonly [{
                        readonly internalType: "address";
                        readonly name: "asset";
                        readonly type: "address";
                    }, {
                        readonly components: readonly [{
                            readonly internalType: "enum ExitFormat.AssetType";
                            readonly name: "assetType";
                            readonly type: "uint8";
                        }, {
                            readonly internalType: "bytes";
                            readonly name: "metadata";
                            readonly type: "bytes";
                        }];
                        readonly internalType: "struct ExitFormat.AssetMetadata";
                        readonly name: "assetMetadata";
                        readonly type: "tuple";
                    }, {
                        readonly components: readonly [{
                            readonly internalType: "bytes32";
                            readonly name: "destination";
                            readonly type: "bytes32";
                        }, {
                            readonly internalType: "uint256";
                            readonly name: "amount";
                            readonly type: "uint256";
                        }, {
                            readonly internalType: "uint8";
                            readonly name: "allocationType";
                            readonly type: "uint8";
                        }, {
                            readonly internalType: "bytes";
                            readonly name: "metadata";
                            readonly type: "bytes";
                        }];
                        readonly internalType: "struct ExitFormat.Allocation[]";
                        readonly name: "allocations";
                        readonly type: "tuple[]";
                    }];
                    readonly internalType: "struct ExitFormat.SingleAssetExit[]";
                    readonly name: "outcome";
                    readonly type: "tuple[]";
                }, {
                    readonly internalType: "bytes";
                    readonly name: "appData";
                    readonly type: "bytes";
                }, {
                    readonly internalType: "uint48";
                    readonly name: "turnNum";
                    readonly type: "uint48";
                }, {
                    readonly internalType: "bool";
                    readonly name: "isFinal";
                    readonly type: "bool";
                }];
                readonly internalType: "struct INitroTypes.VariablePart";
                readonly name: "variablePart";
                readonly type: "tuple";
            }, {
                readonly components: readonly [{
                    readonly internalType: "uint8";
                    readonly name: "v";
                    readonly type: "uint8";
                }, {
                    readonly internalType: "bytes32";
                    readonly name: "r";
                    readonly type: "bytes32";
                }, {
                    readonly internalType: "bytes32";
                    readonly name: "s";
                    readonly type: "bytes32";
                }];
                readonly internalType: "struct INitroTypes.Signature[]";
                readonly name: "sigs";
                readonly type: "tuple[]";
            }];
            readonly internalType: "struct INitroTypes.SignedVariablePart";
            readonly name: "candidate";
            readonly type: "tuple";
        }];
        readonly name: "concludeAndTransferAllAssets";
        readonly outputs: readonly [];
        readonly stateMutability: "nonpayable";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "address";
            readonly name: "asset";
            readonly type: "address";
        }, {
            readonly internalType: "bytes32";
            readonly name: "channelId";
            readonly type: "bytes32";
        }, {
            readonly internalType: "uint256";
            readonly name: "expectedHeld";
            readonly type: "uint256";
        }, {
            readonly internalType: "uint256";
            readonly name: "amount";
            readonly type: "uint256";
        }];
        readonly name: "deposit";
        readonly outputs: readonly [];
        readonly stateMutability: "payable";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "address";
            readonly name: "";
            readonly type: "address";
        }, {
            readonly internalType: "bytes32";
            readonly name: "";
            readonly type: "bytes32";
        }];
        readonly name: "holdings";
        readonly outputs: readonly [{
            readonly internalType: "uint256";
            readonly name: "";
            readonly type: "uint256";
        }];
        readonly stateMutability: "view";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly components: readonly [{
                readonly internalType: "bytes32";
                readonly name: "sourceChannelId";
                readonly type: "bytes32";
            }, {
                readonly internalType: "bytes32";
                readonly name: "sourceStateHash";
                readonly type: "bytes32";
            }, {
                readonly internalType: "bytes";
                readonly name: "sourceOutcomeBytes";
                readonly type: "bytes";
            }, {
                readonly internalType: "uint256";
                readonly name: "sourceAssetIndex";
                readonly type: "uint256";
            }, {
                readonly internalType: "uint256";
                readonly name: "indexOfTargetInSource";
                readonly type: "uint256";
            }, {
                readonly internalType: "bytes32";
                readonly name: "targetStateHash";
                readonly type: "bytes32";
            }, {
                readonly internalType: "bytes";
                readonly name: "targetOutcomeBytes";
                readonly type: "bytes";
            }, {
                readonly internalType: "uint256";
                readonly name: "targetAssetIndex";
                readonly type: "uint256";
            }];
            readonly internalType: "struct IMultiAssetHolder.ReclaimArgs";
            readonly name: "reclaimArgs";
            readonly type: "tuple";
        }];
        readonly name: "reclaim";
        readonly outputs: readonly [];
        readonly stateMutability: "nonpayable";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly components: readonly [{
                readonly internalType: "address[]";
                readonly name: "participants";
                readonly type: "address[]";
            }, {
                readonly internalType: "uint64";
                readonly name: "channelNonce";
                readonly type: "uint64";
            }, {
                readonly internalType: "address";
                readonly name: "appDefinition";
                readonly type: "address";
            }, {
                readonly internalType: "uint48";
                readonly name: "challengeDuration";
                readonly type: "uint48";
            }];
            readonly internalType: "struct INitroTypes.FixedPart";
            readonly name: "fixedPart";
            readonly type: "tuple";
        }, {
            readonly components: readonly [{
                readonly components: readonly [{
                    readonly components: readonly [{
                        readonly internalType: "address";
                        readonly name: "asset";
                        readonly type: "address";
                    }, {
                        readonly components: readonly [{
                            readonly internalType: "enum ExitFormat.AssetType";
                            readonly name: "assetType";
                            readonly type: "uint8";
                        }, {
                            readonly internalType: "bytes";
                            readonly name: "metadata";
                            readonly type: "bytes";
                        }];
                        readonly internalType: "struct ExitFormat.AssetMetadata";
                        readonly name: "assetMetadata";
                        readonly type: "tuple";
                    }, {
                        readonly components: readonly [{
                            readonly internalType: "bytes32";
                            readonly name: "destination";
                            readonly type: "bytes32";
                        }, {
                            readonly internalType: "uint256";
                            readonly name: "amount";
                            readonly type: "uint256";
                        }, {
                            readonly internalType: "uint8";
                            readonly name: "allocationType";
                            readonly type: "uint8";
                        }, {
                            readonly internalType: "bytes";
                            readonly name: "metadata";
                            readonly type: "bytes";
                        }];
                        readonly internalType: "struct ExitFormat.Allocation[]";
                        readonly name: "allocations";
                        readonly type: "tuple[]";
                    }];
                    readonly internalType: "struct ExitFormat.SingleAssetExit[]";
                    readonly name: "outcome";
                    readonly type: "tuple[]";
                }, {
                    readonly internalType: "bytes";
                    readonly name: "appData";
                    readonly type: "bytes";
                }, {
                    readonly internalType: "uint48";
                    readonly name: "turnNum";
                    readonly type: "uint48";
                }, {
                    readonly internalType: "bool";
                    readonly name: "isFinal";
                    readonly type: "bool";
                }];
                readonly internalType: "struct INitroTypes.VariablePart";
                readonly name: "variablePart";
                readonly type: "tuple";
            }, {
                readonly components: readonly [{
                    readonly internalType: "uint8";
                    readonly name: "v";
                    readonly type: "uint8";
                }, {
                    readonly internalType: "bytes32";
                    readonly name: "r";
                    readonly type: "bytes32";
                }, {
                    readonly internalType: "bytes32";
                    readonly name: "s";
                    readonly type: "bytes32";
                }];
                readonly internalType: "struct INitroTypes.Signature[]";
                readonly name: "sigs";
                readonly type: "tuple[]";
            }];
            readonly internalType: "struct INitroTypes.SignedVariablePart[]";
            readonly name: "proof";
            readonly type: "tuple[]";
        }, {
            readonly components: readonly [{
                readonly components: readonly [{
                    readonly components: readonly [{
                        readonly internalType: "address";
                        readonly name: "asset";
                        readonly type: "address";
                    }, {
                        readonly components: readonly [{
                            readonly internalType: "enum ExitFormat.AssetType";
                            readonly name: "assetType";
                            readonly type: "uint8";
                        }, {
                            readonly internalType: "bytes";
                            readonly name: "metadata";
                            readonly type: "bytes";
                        }];
                        readonly internalType: "struct ExitFormat.AssetMetadata";
                        readonly name: "assetMetadata";
                        readonly type: "tuple";
                    }, {
                        readonly components: readonly [{
                            readonly internalType: "bytes32";
                            readonly name: "destination";
                            readonly type: "bytes32";
                        }, {
                            readonly internalType: "uint256";
                            readonly name: "amount";
                            readonly type: "uint256";
                        }, {
                            readonly internalType: "uint8";
                            readonly name: "allocationType";
                            readonly type: "uint8";
                        }, {
                            readonly internalType: "bytes";
                            readonly name: "metadata";
                            readonly type: "bytes";
                        }];
                        readonly internalType: "struct ExitFormat.Allocation[]";
                        readonly name: "allocations";
                        readonly type: "tuple[]";
                    }];
                    readonly internalType: "struct ExitFormat.SingleAssetExit[]";
                    readonly name: "outcome";
                    readonly type: "tuple[]";
                }, {
                    readonly internalType: "bytes";
                    readonly name: "appData";
                    readonly type: "bytes";
                }, {
                    readonly internalType: "uint48";
                    readonly name: "turnNum";
                    readonly type: "uint48";
                }, {
                    readonly internalType: "bool";
                    readonly name: "isFinal";
                    readonly type: "bool";
                }];
                readonly internalType: "struct INitroTypes.VariablePart";
                readonly name: "variablePart";
                readonly type: "tuple";
            }, {
                readonly components: readonly [{
                    readonly internalType: "uint8";
                    readonly name: "v";
                    readonly type: "uint8";
                }, {
                    readonly internalType: "bytes32";
                    readonly name: "r";
                    readonly type: "bytes32";
                }, {
                    readonly internalType: "bytes32";
                    readonly name: "s";
                    readonly type: "bytes32";
                }];
                readonly internalType: "struct INitroTypes.Signature[]";
                readonly name: "sigs";
                readonly type: "tuple[]";
            }];
            readonly internalType: "struct INitroTypes.SignedVariablePart";
            readonly name: "candidate";
            readonly type: "tuple";
        }];
        readonly name: "stateIsSupported";
        readonly outputs: readonly [{
            readonly internalType: "bool";
            readonly name: "";
            readonly type: "bool";
        }, {
            readonly internalType: "string";
            readonly name: "";
            readonly type: "string";
        }];
        readonly stateMutability: "view";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "bytes32";
            readonly name: "";
            readonly type: "bytes32";
        }];
        readonly name: "statusOf";
        readonly outputs: readonly [{
            readonly internalType: "bytes32";
            readonly name: "";
            readonly type: "bytes32";
        }];
        readonly stateMutability: "view";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "uint256";
            readonly name: "assetIndex";
            readonly type: "uint256";
        }, {
            readonly internalType: "bytes32";
            readonly name: "fromChannelId";
            readonly type: "bytes32";
        }, {
            readonly internalType: "bytes";
            readonly name: "outcomeBytes";
            readonly type: "bytes";
        }, {
            readonly internalType: "bytes32";
            readonly name: "stateHash";
            readonly type: "bytes32";
        }, {
            readonly internalType: "uint256[]";
            readonly name: "indices";
            readonly type: "uint256[]";
        }];
        readonly name: "transfer";
        readonly outputs: readonly [];
        readonly stateMutability: "nonpayable";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "bytes32";
            readonly name: "channelId";
            readonly type: "bytes32";
        }, {
            readonly components: readonly [{
                readonly internalType: "address";
                readonly name: "asset";
                readonly type: "address";
            }, {
                readonly components: readonly [{
                    readonly internalType: "enum ExitFormat.AssetType";
                    readonly name: "assetType";
                    readonly type: "uint8";
                }, {
                    readonly internalType: "bytes";
                    readonly name: "metadata";
                    readonly type: "bytes";
                }];
                readonly internalType: "struct ExitFormat.AssetMetadata";
                readonly name: "assetMetadata";
                readonly type: "tuple";
            }, {
                readonly components: readonly [{
                    readonly internalType: "bytes32";
                    readonly name: "destination";
                    readonly type: "bytes32";
                }, {
                    readonly internalType: "uint256";
                    readonly name: "amount";
                    readonly type: "uint256";
                }, {
                    readonly internalType: "uint8";
                    readonly name: "allocationType";
                    readonly type: "uint8";
                }, {
                    readonly internalType: "bytes";
                    readonly name: "metadata";
                    readonly type: "bytes";
                }];
                readonly internalType: "struct ExitFormat.Allocation[]";
                readonly name: "allocations";
                readonly type: "tuple[]";
            }];
            readonly internalType: "struct ExitFormat.SingleAssetExit[]";
            readonly name: "outcome";
            readonly type: "tuple[]";
        }, {
            readonly internalType: "bytes32";
            readonly name: "stateHash";
            readonly type: "bytes32";
        }];
        readonly name: "transferAllAssets";
        readonly outputs: readonly [];
        readonly stateMutability: "nonpayable";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "bytes32";
            readonly name: "channelId";
            readonly type: "bytes32";
        }];
        readonly name: "unpackStatus";
        readonly outputs: readonly [{
            readonly internalType: "uint48";
            readonly name: "turnNumRecord";
            readonly type: "uint48";
        }, {
            readonly internalType: "uint48";
            readonly name: "finalizesAt";
            readonly type: "uint48";
        }, {
            readonly internalType: "uint160";
            readonly name: "fingerprint";
            readonly type: "uint160";
        }];
        readonly stateMutability: "view";
        readonly type: "function";
    }];
    static createInterface(): NitroAdjudicatorInterface;
    static connect(address: string, signerOrProvider: Signer | Provider): NitroAdjudicator;
}
