import { Signer } from "ethers";
import type { Provider } from "@ethersproject/providers";
import type { VirtualPaymentApp, VirtualPaymentAppInterface } from "../VirtualPaymentApp";
export declare class VirtualPaymentApp__factory {
    static readonly abi: readonly [{
        readonly inputs: readonly [{
            readonly components: readonly [{
                readonly internalType: "address[]";
                readonly name: "participants";
                readonly type: "address[]";
            }, {
                readonly internalType: "uint64";
                readonly name: "channelNonce";
                readonly type: "uint64";
            }, {
                readonly internalType: "address";
                readonly name: "appDefinition";
                readonly type: "address";
            }, {
                readonly internalType: "uint48";
                readonly name: "challengeDuration";
                readonly type: "uint48";
            }];
            readonly internalType: "struct INitroTypes.FixedPart";
            readonly name: "fixedPart";
            readonly type: "tuple";
        }, {
            readonly components: readonly [{
                readonly components: readonly [{
                    readonly components: readonly [{
                        readonly internalType: "address";
                        readonly name: "asset";
                        readonly type: "address";
                    }, {
                        readonly components: readonly [{
                            readonly internalType: "enum ExitFormat.AssetType";
                            readonly name: "assetType";
                            readonly type: "uint8";
                        }, {
                            readonly internalType: "bytes";
                            readonly name: "metadata";
                            readonly type: "bytes";
                        }];
                        readonly internalType: "struct ExitFormat.AssetMetadata";
                        readonly name: "assetMetadata";
                        readonly type: "tuple";
                    }, {
                        readonly components: readonly [{
                            readonly internalType: "bytes32";
                            readonly name: "destination";
                            readonly type: "bytes32";
                        }, {
                            readonly internalType: "uint256";
                            readonly name: "amount";
                            readonly type: "uint256";
                        }, {
                            readonly internalType: "uint8";
                            readonly name: "allocationType";
                            readonly type: "uint8";
                        }, {
                            readonly internalType: "bytes";
                            readonly name: "metadata";
                            readonly type: "bytes";
                        }];
                        readonly internalType: "struct ExitFormat.Allocation[]";
                        readonly name: "allocations";
                        readonly type: "tuple[]";
                    }];
                    readonly internalType: "struct ExitFormat.SingleAssetExit[]";
                    readonly name: "outcome";
                    readonly type: "tuple[]";
                }, {
                    readonly internalType: "bytes";
                    readonly name: "appData";
                    readonly type: "bytes";
                }, {
                    readonly internalType: "uint48";
                    readonly name: "turnNum";
                    readonly type: "uint48";
                }, {
                    readonly internalType: "bool";
                    readonly name: "isFinal";
                    readonly type: "bool";
                }];
                readonly internalType: "struct INitroTypes.VariablePart";
                readonly name: "variablePart";
                readonly type: "tuple";
            }, {
                readonly internalType: "uint256";
                readonly name: "signedBy";
                readonly type: "uint256";
            }];
            readonly internalType: "struct INitroTypes.RecoveredVariablePart[]";
            readonly name: "proof";
            readonly type: "tuple[]";
        }, {
            readonly components: readonly [{
                readonly components: readonly [{
                    readonly components: readonly [{
                        readonly internalType: "address";
                        readonly name: "asset";
                        readonly type: "address";
                    }, {
                        readonly components: readonly [{
                            readonly internalType: "enum ExitFormat.AssetType";
                            readonly name: "assetType";
                            readonly type: "uint8";
                        }, {
                            readonly internalType: "bytes";
                            readonly name: "metadata";
                            readonly type: "bytes";
                        }];
                        readonly internalType: "struct ExitFormat.AssetMetadata";
                        readonly name: "assetMetadata";
                        readonly type: "tuple";
                    }, {
                        readonly components: readonly [{
                            readonly internalType: "bytes32";
                            readonly name: "destination";
                            readonly type: "bytes32";
                        }, {
                            readonly internalType: "uint256";
                            readonly name: "amount";
                            readonly type: "uint256";
                        }, {
                            readonly internalType: "uint8";
                            readonly name: "allocationType";
                            readonly type: "uint8";
                        }, {
                            readonly internalType: "bytes";
                            readonly name: "metadata";
                            readonly type: "bytes";
                        }];
                        readonly internalType: "struct ExitFormat.Allocation[]";
                        readonly name: "allocations";
                        readonly type: "tuple[]";
                    }];
                    readonly internalType: "struct ExitFormat.SingleAssetExit[]";
                    readonly name: "outcome";
                    readonly type: "tuple[]";
                }, {
                    readonly internalType: "bytes";
                    readonly name: "appData";
                    readonly type: "bytes";
                }, {
                    readonly internalType: "uint48";
                    readonly name: "turnNum";
                    readonly type: "uint48";
                }, {
                    readonly internalType: "bool";
                    readonly name: "isFinal";
                    readonly type: "bool";
                }];
                readonly internalType: "struct INitroTypes.VariablePart";
                readonly name: "variablePart";
                readonly type: "tuple";
            }, {
                readonly internalType: "uint256";
                readonly name: "signedBy";
                readonly type: "uint256";
            }];
            readonly internalType: "struct INitroTypes.RecoveredVariablePart";
            readonly name: "candidate";
            readonly type: "tuple";
        }];
        readonly name: "stateIsSupported";
        readonly outputs: readonly [{
            readonly internalType: "bool";
            readonly name: "";
            readonly type: "bool";
        }, {
            readonly internalType: "string";
            readonly name: "";
            readonly type: "string";
        }];
        readonly stateMutability: "pure";
        readonly type: "function";
    }];
    static createInterface(): VirtualPaymentAppInterface;
    static connect(address: string, signerOrProvider: Signer | Provider): VirtualPaymentApp;
}
