"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WrappedError = void 0;
const lodash_1 = __importDefault(require("lodash"));
class WrappedError extends Error {
    constructor(message, errors) {
        super(`${message}: ${errors.message}`);
        this.errors = [];
        this.errors = [errors];
    }
    static is(error, targetError) {
        if (lodash_1.default.isEqual(error, targetError)) {
            return true;
        }
        if (error instanceof WrappedError) {
            for (let i = 0; i < error.errors.length; i += 1) {
                if (WrappedError.is(error.errors[i], targetError)) {
                    return true;
                }
            }
        }
        return false;
    }
}
exports.WrappedError = WrappedError;
//# sourceMappingURL=error.js.map