"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("mocha");
const chai_1 = require("chai");
const error_1 = require("./error");
const EXPECTED_NESTED_ERROR = 'WrappedError 3: WrappedError 2: WrappedError 1: Error 1';
describe('Test WrappedError', () => {
    it('Print nested error', () => {
        const err1 = new Error('Error 1');
        const wErr1 = new error_1.WrappedError('WrappedError 1', err1);
        const wErr2 = new error_1.WrappedError('WrappedError 2', wErr1);
        const wErr3 = new error_1.WrappedError('WrappedError 3', wErr2);
        (0, chai_1.expect)(wErr3.message).to.be.equal(EXPECTED_NESTED_ERROR);
    });
});
//# sourceMappingURL=error.test.js.map