"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.go = void 0;
const debug_1 = __importDefault(require("debug"));
const log = (0, debug_1.default)('ts-nitro:util:go');
// Placeholder function for go routines
// TODO: Avoid any type with method overloading
const go = (func, ...params) => __awaiter(void 0, void 0, void 0, function* () {
    try {
        yield func(...params);
    }
    catch (err) {
        log(err);
        throw err;
    }
});
exports.go = go;
//# sourceMappingURL=go.js.map