"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getBalanceByKey = exports.getBalanceByAddress = exports.getAddressByKey = void 0;
const ethers_1 = require("ethers");
function getAddressByKey(chainPrivateKey, chainURL) {
    return __awaiter(this, void 0, void 0, function* () {
        const provider = new ethers_1.providers.JsonRpcProvider(chainURL);
        const signer = new ethers_1.Wallet(chainPrivateKey, provider);
        return signer.getAddress();
    });
}
exports.getAddressByKey = getAddressByKey;
function getBalanceByAddress(address, chainURL) {
    return __awaiter(this, void 0, void 0, function* () {
        const provider = new ethers_1.providers.JsonRpcProvider(chainURL);
        return provider.getBalance(address);
    });
}
exports.getBalanceByAddress = getBalanceByAddress;
function getBalanceByKey(chainPrivateKey, chainURL) {
    return __awaiter(this, void 0, void 0, function* () {
        const address = yield getAddressByKey(chainPrivateKey, chainURL);
        return getBalanceByAddress(address, chainURL);
    });
}
exports.getBalanceByKey = getBalanceByKey;
//# sourceMappingURL=misc.js.map