"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Ticker = void 0;
const ts_channel_1 = __importDefault(require("@cerc-io/ts-channel"));
// https://pkg.go.dev/time#Ticker
class Ticker {
    constructor(d) {
        this.c = (0, ts_channel_1.default)(1);
        this.intervalId = setInterval(() => __awaiter(this, void 0, void 0, function* () {
            yield this.c.push(new Date());
        }), d);
    }
    static newTicker(d) {
        return __awaiter(this, void 0, void 0, function* () {
            if (d <= 0) {
                throw new Error('non-positive interval for NewTicker');
            }
            const t = new Ticker(d);
            return t;
        });
    }
    stop() {
        clearInterval(this.intervalId);
    }
}
exports.Ticker = Ticker;
//# sourceMappingURL=ticker.js.map