"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
require("mocha");
const chai_1 = require("chai");
const ts_channel_1 = __importDefault(require("@cerc-io/ts-channel"));
const ticker_1 = require("./ticker");
const TICKER_DURATION = 1000;
const TEST_DURATION = 10000;
const EXPECTED_TICK_COUNT = TEST_DURATION / TICKER_DURATION;
describe('Test Ticker', () => {
    it('Test ticker count', () => __awaiter(void 0, void 0, void 0, function* () {
        const ticker = yield ticker_1.Ticker.newTicker(TICKER_DURATION);
        let tickerCount = 0;
        const completeChannel = (0, ts_channel_1.default)();
        setTimeout(() => {
            completeChannel.push(true);
        }, TEST_DURATION);
        while (true) {
            // eslint-disable-next-line default-case, no-await-in-loop
            switch (yield ts_channel_1.default.select([
                completeChannel.shift(),
                ticker.c.shift(),
            ])) {
                case completeChannel: {
                    ticker.stop();
                    (0, chai_1.expect)(tickerCount).to.be.within(EXPECTED_TICK_COUNT - 1, EXPECTED_TICK_COUNT + 1);
                    return;
                }
                case ticker.c: {
                    tickerCount += 1;
                    break;
                }
            }
        }
    }));
});
//# sourceMappingURL=ticker.test.js.map